/*
 * Avengers Magic 8 Ball
 * by Giovanni Bernardo (cyb3rn0id)
 * https://www.settorezero.com/wordpress/m5stick-avengers-magic-8-ball/
 * 
 */
#include <M5StickC.h>
#include "images.h" // arrays with images
void setup() 
  {
  M5.begin();
  M5.Lcd.fillScreen(BLACK);
  M5.Lcd.setRotation(4);
  M5.Axp.ScreenBreath(10);       
  M5.MPU6886.Init();
  }
 
void loop() 
  {
  static float prevX=0;
  static float prevY=0;
  static float prevZ=0;
  static float nowX=0;
  static float nowY=0; 
  static float nowZ=0;
  static long prevtime=0;
  static bool shaking=false;
  static uint8_t shakecount=0;
  static uint8_t score=0;

  M5.MPU6886.getAccelData(&nowX,&nowY,&nowZ); // read accelerometer
  delay(100); // needed to give some time for computation
  
  if (abs(nowX-prevX)>0.4) score++;
  if (abs(nowY-prevY)>0.4) score++;
  if (abs(nowZ-prevZ)>0.4) score++;

  if (score>1) // at least 2 axis involved
    {
    if ((millis()-prevtime)<1000)
        {
        shakecount++;  
        if (shakecount==3)
          {
          shaking=true;  
          shakecount=0;
          }
        }
    else
        {
        shakecount=0;
        }
      }
  else
    {
    shakecount=0;
    }
    
  prevtime=millis();
  prevX=nowX;
  prevY=nowY;
  prevZ=nowZ;
  score=0; 
      
  if (shaking)
    {
    static int8_t im=-1; // actual image
    static int8_t previm=-1; // previous image
    while (im==previm) // stay in loop until the freshly generated number is different than the previous
      {
      im=random(26); // generate a random number from 0 to 25
      }
    previm=im; // remember the number for the next shaking
    shaking=false; // reset the shaking flag
    M5.Lcd.pushImage(0,0,80,160, (uint16_t *)avengers[im]); // load the image on the LCD
    delay(1500);
    } // \shaking
  }
